name: Build and Test

on:
  push:
    branches:
    - main
  pull_request:
  workflow_dispatch:

defaults:
  run:
    shell: bash

jobs:

  build:
    strategy:
      # run all tests even if e.g. image tests fail early
      fail-fast: false
      matrix:
        os:
        - ubuntu-latest
        python-version:
        - '3.9'
        - '3.10'
        - '3.11'
        - '3.12'
        # Test all on ubuntu, test ends on macos and windows
        include:
        - os: macos-latest
          python-version: '3.9'
        - os: windows-latest
          python-version: '3.9'
        - os: macos-latest
          python-version: '3.12'
        - os: windows-latest
          python-version: '3.12'
        - os: ubuntu-20.04
          python-version: '3.9'
          deps: minimal

    runs-on: ${{ matrix.os }}

    steps:
    - name: Checkout repo
      uses: actions/checkout@v4
    - name: Set up Python
      uses: actions/setup-python@v5
      with:
        python-version: ${{ matrix.python-version }}
    - uses: yezz123/setup-uv@v4
      with:
        uv-version: 0.2.33
        uv-venv: .venv

    - run: uv pip install --requirement test_requirements.txt

    - if: matrix.deps == 'minimal'
      run: |
        uv pip compile pyproject.toml --resolution=lowest-direct | uv pip install -r -

    - name: Build
      run: uv pip install --editable "."

    - run: uv pip list

    - name: Run Tests
      run: pytest --color=yes
